org.eclipse.cdt.core.dom.ast

## Interface IASTSimpleDeclaration

All Superinterfaces:
  IASTAttributeOwner, IASTDeclaration, IASTNode

    public interface IASTSimpleDeclaration
    extends IASTDeclaration, IASTAttributeOwner

This is a simple declaration which contains a sequence of declSpecifiers followed by a list of declarators.

### Nested Class Summary

### Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`IASTNode.CopyStyle`

### Field Summary

Fields
`static ASTNodeProperty` `DECL_SPECIFIER` `DECL_SPECIFIER` represents the relationship between an `IASTSimpleDeclaration` and it's nested `IASTDeclSpecifier`.
`static ASTNodeProperty` `DECLARATOR` `DECLARATOR` represents the relationship between an `IASTSimpleDeclaration` and it's nested `IASTDeclarator`s.

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTDeclaration

`EMPTY_DECLARATION_ARRAY`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTAttributeOwner

`ATTRIBUTE, ATTRIBUTE_SPECIFIER`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`EMPTY_NODE_ARRAY`

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `addDeclarator(IASTDeclarator declarator)` Add a declarator.
`IASTSimpleDeclaration` `copy()` Returns a mutable copy of the tree rooted at this node.
`IASTSimpleDeclaration` `copy(IASTNode.CopyStyle style)` Returns a mutable copy of the tree rooted at this node.
`IASTDeclarator[]` `getDeclarators()` This returns the list of declarators in this declaration.
`IASTDeclSpecifier` `getDeclSpecifier()` This returns the object representing the declSpecifiers for this declaration.
`void` `setDeclSpecifier(IASTDeclSpecifier declSpec)` Set the decl specifier.

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTAttributeOwner

`addAttribute, addAttributeSpecifier, getAttributes, getAttributeSpecifiers`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`accept, contains, getChildren, getContainingFilename, getFileLocation, getLeadingSyntax, getNodeLocations, getOriginalNode, getParent, getPropertyInParent, getRawSignature, getSyntax, getTrailingSyntax, getTranslationUnit, isActive, isFrozen, isPartOfTranslationUnitFile, setParent, setPropertyInParent`

### Field Detail

#### DECL_SPECIFIER

    static final ASTNodeProperty DECL_SPECIFIER

`DECL_SPECIFIER` represents the relationship between an `IASTSimpleDeclaration` and it's nested `IASTDeclSpecifier`.

#### DECLARATOR

    static final ASTNodeProperty DECLARATOR

`DECLARATOR` represents the relationship between an `IASTSimpleDeclaration` and it's nested `IASTDeclarator`s.

### Method Detail

#### getDeclSpecifier

    IASTDeclSpecifier getDeclSpecifier()

This returns the object representing the declSpecifiers for this declaration.

Returns:
  the declSpecifier object

#### setDeclSpecifier

    void setDeclSpecifier(IASTDeclSpecifier declSpec)

Set the decl specifier.

Parameters:
  `declSpec` - `IASTDeclSpecifier`

#### getDeclarators

    IASTDeclarator[] getDeclarators()

This returns the list of declarators in this declaration.

Returns:
  `IASTDeclarator []`

#### addDeclarator

    void addDeclarator(IASTDeclarator declarator)

Add a declarator.

Parameters:
  `declarator` - `IASTDeclarator`

#### copy

    IASTSimpleDeclaration copy()

Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Calling this method is equivalent to `copy(CopyStyle.withoutLocations)`.

Specified by:
  `copy` in interface `IASTDeclaration`
Specified by:
  `copy` in interface `IASTNode`
Since:
  5.1

#### copy

    IASTSimpleDeclaration copy(IASTNode.CopyStyle style)

Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Specified by:
  `copy` in interface `IASTDeclaration`
Specified by:
  `copy` in interface `IASTNode`
Parameters:
  `style` - `IASTNode.CopyStyle` create a copy with or without locations. Please see `IASTNode.CopyStyle` for restrictions on copies with Locations.
Since:
  5.3